﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
using HEAL.Attic;
using HeuristicLab.Common;
using HeuristicLab.Optimization;

namespace HeuristicLab.Problems.DataAnalysis.Symbolic.Regression {
  [StorableType("30B1B5C6-09D9-44C5-BC56-A57F3186E0D2")]
  public class SymbolicRegressionMultiObjectiveMetaModelAnalyzer
      : SymbolicRegressionMetaModelAnalyzer<SymbolicRegressionMultiObjectiveProblem>, ISymbolicExpressionTreeAnalyzer {

    [StorableConstructor]
    protected SymbolicRegressionMultiObjectiveMetaModelAnalyzer
    (StorableConstructorFlag _) : base(_) {
    }

    protected SymbolicRegressionMultiObjectiveMetaModelAnalyzer(SymbolicRegressionMultiObjectiveMetaModelAnalyzer original, Cloner cloner) 
      : base(original, cloner) { }

    public SymbolicRegressionMultiObjectiveMetaModelAnalyzer() {

    }

    public override IDeepCloneable Clone(Cloner cloner) => 
      new SymbolicRegressionMultiObjectiveMetaModelAnalyzer(this, cloner);

    protected override void PerformApply(
      SymbolicRegressionMultiObjectiveProblem baseProblem,
      IEnumerable<SymbolicRegressionMultiObjectiveProblem> problems,
      string targetVariable) {
      
      //double bestQuality = problem.Maximization.Value ? double.MinValue : double.MaxValue;
      //var trees = SymbolicExpressionTree.ToArray();
      //IDataset dataset = problem.ProblemData.Dataset;
      //IEnumerable<int> rows = Enumerable.Range(0, dataset.Rows);
      //var paretoFront = DominationCalculator<ISymbolicExpressionTree>.CalculateBestParetoFront(trees,
      //  trees.Select(x => problem.Evaluator.Evaluate(ExecutionContext, x, problem.ProblemData, rows)).ToArray(), 
      //  problem.Maximization.ToArray());

      //SymbolicRegressionSolution bestMetaModel = null;
      //foreach (var tree in this.SymbolicExpressionTree.ToArray()) { // iterate pareto front
        
      //  var quality = problem.Evaluator.Evaluate(ExecutionContext, tree, problem.ProblemData, rows);
      //  /*
      //  bool isBetter = problem.Maximization.Value ? (bestQuality < quality) : (bestQuality > quality);
      //  if (isBetter) {
      //    bestQuality = quality;
      //    var model = new SymbolicRegressionModel(
      //      targetVariable,
      //      (ISymbolicExpressionTree)tree.Clone(),
      //      new SymbolicDataAnalysisExpressionTreeInterpreter());
      //    bestMetaModel = new SymbolicRegressionSolution(model, problem.ProblemData);
      //  }*/
      //}
      //BestMetaModelParameter.ActualValue = bestMetaModel;
    }
  }
}
